addhook("startround","mirr_roundstart")
addhook("hitzone","mirr_hitzone")
addhook("ms100","mirr_ms100")

parse("restart")

mirr = {}
mirr.tileVar = {}
mirr.tileVarb = {}
mirr.tileVarc = {}
mirr.tileVard = {}
mirr.tileVare = {}
mirr.tileVarf = {}
mirr.tileVarg= {}
mirr.tileVarh = {}
mirr.tileVari = {}
mirr.tileVarj = {}

function mirr_roundstart()
	imid = 0
	for x = 0, map'xsize' do
		mirr.tileVar[x] = {}
		mirr.tileVarb[x] = {}
		mirr.tileVarc[x] = {}
		mirr.tileVard[x] = {}
		mirr.tileVare[x] = {}
		mirr.tileVarf[x] = {}
		mirr.tileVarg[x] = {}
		mirr.tileVarh[x] = {}
		mirr.tileVari[x] = {}
		mirr.tileVarj[x] = {}
		for y = 0, map'ysize' do
			if entity(x,y,"typename") == "Func_DynWall" then
				if entity(x,y,"name") == "mirror" then
					
					imid = imid + 1
					
					mirr.tileVar[imid]=image("gfx/pseudon/entity03/device.bmp",x * 32 + 16,y * 32 +16,3)
					mirr.tileVarb[imid]=image("gfx/pseudon/entity03/deviceshade.bmp",x * 32 + 32,y * 32 + 32,0)
					mirr.tileVarc[imid]=image("gfx/pseudon/entity03/mirrora.bmp",x * 32 + 16,y * 32 + 16,3)
					mirr.tileVard[imid]=image("gfx/pseudon/entity03/mirrora.bmp",x * 32 + 16,y * 32 + 16,3)
					mirr.tileVare[imid]=image("gfx/pseudon/entity03/mirrora.bmp",x * 32 + 16,y * 32 + 16,3)
					mirr.tileVarf[imid]=image("gfx/pseudon/entity03/mirrora.bmp",x * 32 + 16,y * 32 + 16,3)
					mirr.tileVarg[imid]=image("gfx/pseudon/entity03/mirrora.bmp",x * 32 + 16,y * 32 + 16,3)
					mirr.tileVarh[imid]=image("gfx/pseudon/entity03/mirrora.bmp",x * 32 + 16,y * 32 + 16,3)
					mirr.tileVari[imid]=image("gfx/pseudon/entity03/mirrora.bmp",x * 32 + 16,y * 32 + 16,3)
					mirr.tileVarj[imid]=image("gfx/pseudon/entity03/mirrora.bmp",x * 32 + 16,y * 32 + 16,3)
					
					tween_rotateconstantly(mirr.tileVarc[imid],-10)
					tween_rotateconstantly(mirr.tileVard[imid],9)
					tween_rotateconstantly(mirr.tileVare[imid],-8)
					tween_rotateconstantly(mirr.tileVarf[imid],7)
					tween_rotateconstantly(mirr.tileVarg[imid],-6)
					tween_rotateconstantly(mirr.tileVarh[imid],5)
					tween_rotateconstantly(mirr.tileVari[imid],-4)
					tween_rotateconstantly(mirr.tileVarj[imid],3)
					
					imageblend(mirr.tileVarb[imid],2)
					imagecolor(mirr.tileVarc[imid],000,255,155)
					imageblend(mirr.tileVarc[imid],1)
					imagescale(mirr.tileVarc[imid],1.2,1.2)
					imagecolor(mirr.tileVard[imid],000,255,055)
					imageblend(mirr.tileVard[imid],1)
					imagescale(mirr.tileVard[imid],1.2,1.2)
					imagecolor(mirr.tileVare[imid],055,255,000)
					imageblend(mirr.tileVare[imid],1)
					imagecolor(mirr.tileVarf[imid],100,200,000)
					imageblend(mirr.tileVarf[imid],1)
					imagecolor(mirr.tileVarg[imid],155,155,000)
					imageblend(mirr.tileVarg[imid],1)
					imagescale(mirr.tileVarg[imid],0.8,0.8)
					imagecolor(mirr.tileVarh[imid],200,100,000)
					imageblend(mirr.tileVarh[imid],1)
					imagescale(mirr.tileVarh[imid],0.8,0.8)
					imagecolor(mirr.tileVari[imid],255,055,000)
					imageblend(mirr.tileVari[imid],1)
					imagescale(mirr.tileVari[imid],0.6,0.6)
					imagecolor(mirr.tileVarj[imid],255,000,055)
					imageblend(mirr.tileVarj[imid],1)
					imagescale(mirr.tileVarj[imid],0.6,0.6)
					
					imagehitzone(mirr.tileVar[imid],2,-32/2,-32/2,32,32)
				end
			end
		end
	end
end

function mirr_hitzone(iid,id,oid,w,x,y,d)
	xe = x / 32
	ye = y / 32
	local x3, x2 = math.modf(xe)
	local y3, y2 = math.modf(ye)
	for i = 0,imid do
		if iid == mirr.tileVar[i] then
			parse("effect \"flare\" "..x.." "..y.." 1 1 255 100 100")
			if player(id,"health") > 1 then
				parse("sethealth "..id.." "..player(id,"health")/2)
			else
				parse("customkill "..id.." \"Damage Mirror\" "..id)
			end
		end
	end
end

mirr.count = 0

function mirr_ms100()
	for x = 0, map'xsize' do
		for y = 0, map'ysize' do
			if entity(x,y,"typename") == "Func_DynWall" then
				if entity(x,y,"name") == "mirror" then
					if mirr.count == 5 then
						parse("effect \"flare\" "..(x * 32 + 16).." "..(y * 32 + 16).." 1 1 255 000 000")
					elseif mirr.count == 10 then
						parse("effect \"flare\" "..(x * 32 + 16).." "..(y * 32 + 16).." 1 1 255 255 000")
					elseif mirr.count == 15 then
						parse("effect \"flare\" "..(x * 32 + 16).." "..(y * 32 + 16).." 1 1 000 000 255")
						mirr.count = 0
					end
					mirr.count = mirr.count + 1
				end
			end
		end
	end
end